# MyFirstUDRKit

Welcome to MyFirstUDRKit. As you can tell from the name, this plugin is not intended for production use. It is just to play with. When you are ready feel free to fork it and give it a new name.


### Forking the repository

For test purposes you can just clone the repo and try building and testing the code. However, for serious work it is recommended that you clone the repo and give the project a new name. When doing so be sure to search and replace all references to MyFirstUDRKit to your new project name. There are two strings to replace:

```
MyFirstUDRKit
MY_FIRST_UDR_KIT
```


### Setting up cmake

Run the cmake gui and fill in the path information. Set the source to the root of the location where you have cloned the repo. CMake looks for the file `CMakeLists.txt`. Binaries will be built under `build/x86_64-windows` and `build/x86_64-linux` for linux.

![cmake - pre-config](docs/images/cmake_before_config.png "cmake pre-config")

Click on Configure to generate the default config for the current platform. When prompted choose the `Unix makefiles` generator for linux and `Visual Studio 2019`or later for windows

You should then see a screen like this:

![cmake - config](docs/images/cmake_config.png "cmake config")

The only change needed at this stage is to set `CMAKE_BUILD_TYPE to `Debug`

You can then click on `Generate` and you should end up with a screen similar to this:

![cmake - config](docs/images/cmake_generate.png "cmake generate")



If you want to start again be sure to click on `FILE|DELETE CACHE`


### Building the kit

```
cd builds
make
```


### Installation

#### run the sql on the target database
Decide whether to install the functions globally or as part of a package



### Testing

- create a test db
- add functions
- write some simple tests


### Stress testing

- compile fb for valgrind
- stress test for leakage


### When things go wrong

#### Errors when registering a function

```
Invalid index 1 in function IMetadataBuilder::setType
```

This error indicates that the parameters in the sql function declaration do not match the parameters in the actual function. Check your sql with the FB_UDR_MESSAGE declarations.






### TODO
